Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.net
Class URL

    java.lang.Object
      |
      +--java.net.URL

All Implemented Interfaces:
  Serializable

public final class URL
extends Object
implements Serializable

Class `URL` represents a Uniform Resource Locator, a pointer to a "resource" on the World Wide Web. A resource can be something as simple as a file or a directory, or it can be a reference to a more complicated object, such as a query to a database or to a search engine. More information on the types of URLs and their formats can be found at:

>          http://www.ncsa.uiuc.edu/demoweb/url-primer.html

In general, a URL can be broken into several parts. The previous example of a URL indicates that the protocol to use is `http` (HyperText Transfer Protocol) and that the information resides on a host machine named `www.ncsa.uiuc.edu`. The information on that host machine is named `/demoweb/url-primer.html`. The exact meaning of this name on the host machine is both protocol dependent and host dependent. The information normally resides in a file, but it could be generated on the fly. This component of the URL is called the path component.

A URL can optionally specify a "port", which is the port number to which the TCP connection is made on the remote host machine. If the port is not specified, the default port for the protocol is used instead. For example, the default port for `http` is `80`. An alternative port could be specified as:

>          http://www.ncsa.uiuc.edu:8080/demoweb/url-primer.html

A URL may have appended to it a "fragment", also known as a "ref" or a "reference". The fragment is indicated by the sharp sign character "#" followed by more characters. For example,

>          http://java.sun.com/index.html#chapter1

This fragment is not technically part of the URL. Rather, it indicates that after the specified resource is retrieved, the application is specifically interested in that part of the document that has the tag `chapter1` attached to it. The meaning of a tag is resource specific.

An application can also specify a "relative URL", which contains only enough information to reach the resource relative to another URL. Relative URLs are frequently used within HTML pages. For example, if the contents of the URL:

>          http://java.sun.com/index.html

contained within it the relative URL:

>          FAQ.html

it would be a shorthand for:

>          http://java.sun.com/FAQ.html

The relative URL need not specify all the components of a URL. If the protocol, host name, or port number is missing, the value is inherited from the fully specified URL. The file component must be specified. The optional fragment is not inherited.

Since:
  JDK1.0
See Also:
  Serialized Form

Constructor Summary
`URL(String spec)` Creates a `URL` object from the `String` representation.
`URL(String protocol, String host, int port, String file)` Creates a `URL` object from the specified `protocol`, `host`, `port` number, and `file`.
`URL(String protocol, String host, int port, String file, URLStreamHandler handler)` Creates a `URL` object from the specified `protocol`, `host`, `port` number, `file`, and `handler`.
`URL(String protocol, String host, String file)` Creates a URL from the specified `protocol` name, `host` name, and `file` name.
`URL(URL context, String spec)` Creates a URL by parsing the given spec within a specified context.
`URL(URL context, String spec, URLStreamHandler handler)` Creates a URL by parsing the given spec with the specified handler within a specified context.

Method Summary
`boolean` | `equals(Object obj)` Compares two URLs.
`String` | `getAuthority()` Returns the authority part of this `URL`.
`Object` | `getContent()` Returns the contents of this URL.
`Object` | `getContent(Class[] classes)` Returns the contents of this URL.
`String` | `getFile()` Returns the file name of this `URL`.
`String` | `getHost()` Returns the host name of this `URL`, if applicable.
`String` | `getPath()` Returns the path part of this `URL`.
`int` | `getPort()` Returns the port number of this `URL`.
`String` | `getProtocol()` Returns the protocol name of this `URL`.
`String` | `getQuery()` Returns the query part of this `URL`.
`String` | `getRef()` Returns the anchor (also known as the "reference") of this `URL`.
`String` | `getUserInfo()` Returns the userInfo part of this `URL`.
`int` | `hashCode()` Creates an integer suitable for hash table indexing.
`URLConnection` | `openConnection()` Returns a `URLConnection` object that represents a connection to the remote object referred to by the `URL`.
`InputStream` | `openStream()` Opens a connection to this `URL` and returns an `InputStream` for reading from that connection.
`boolean` | `sameFile(URL other)` Compares two URLs, excluding the "ref" fields.
`protected void` | `set(String protocol, String host, int port, String file, String ref)` Sets the fields of the URL.
`protected void` | `set(String protocol, String host, int port, String authority, String userInfo, String path, String query, String ref)` Sets the specified 8 fields of the URL.
`static void` | `setURLStreamHandlerFactory(URLStreamHandlerFactory fac)` Sets an application's `URLStreamHandlerFactory`.
`String` | `toExternalForm()` Constructs a string representation of this `URL`.
`String` | `toString()` Constructs a string representation of this `URL`.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### URL

    public URL(String protocol,
               String host,
               int port,
               String file)
        throws MalformedURLException

  Creates a `URL` object from the specified `protocol`, `host`, `port` number, and `file`. Specifying a `port` number of `-1` indicates that the URL should use the default port for the protocol.

  If this is the first URL object being created with the specified protocol, a stream protocol handler object, an instance of class `URLStreamHandler`, is created for that protocol:

  1. If the application has previously set up an instance of `URLStreamHandlerFactory` as the stream handler factory, then the `createURLStreamHandler` method of that instance is called with the protocol string as an argument to create the stream protocol handler.
  2. If no `URLStreamHandlerFactory` has yet been set up, or if the factory's `createURLStreamHandler` method returns `null`, then the constructor finds the value of the system property:

     >              java.protocol.handler.pkgs

     If the value of that system property is not `null`, it is interpreted as a list of packages separated by a vertical slash character '`|`'. The constructor tries to load the class named:

     >              <package>.<protocol>.Handler

     where <package> is replaced by the name of the package and <protocol> is replaced by the name of the protocol. If this class does not exist, or if the class exists but it is not a subclass of `URLStreamHandler`, then the next package in the list is tried.
  3. If the previous step fails to find a protocol handler, then the constructor tries to load the class named:

     >              sun.net.www.protocol.<protocol>.Handler

     If this class does not exist, or if the class exists but it is not a subclass of `URLStreamHandler`, then a `MalformedURLException` is thrown.
  Parameters:
    `protocol` - the name of the protocol to use.
    `host` - the name of the host.
    `port` - the port number on the host.
    `file` - the file on the host
  Throws:
    `MalformedURLException` - if an unknown protocol is specified.
  See Also:
    `System.getProperty(java.lang.String)`, `setURLStreamHandlerFactory(java.net.URLStreamHandlerFactory)`, `URLStreamHandler`, `URLStreamHandlerFactory.createURLStreamHandler(java.lang.String)`

### URL

    public URL(String protocol,
               String host,
               String file)
        throws MalformedURLException

  Creates a URL from the specified `protocol` name, `host` name, and `file` name. The default port for the specified protocol is used.

  This method is equivalent to calling the four-argument constructor with the arguments being `protocol`, `host`, `-1`, and `file`.

  Parameters:
    `protocol` - the name of the protocol to use.
    `host` - the name of the host.
    `file` - the file on the host.
  Throws:
    `MalformedURLException` - if an unknown protocol is specified.
  See Also:
    `URL(java.lang.String, java.lang.String, int, java.lang.String)`

### URL

    public URL(String protocol,
               String host,
               int port,
               String file,
               URLStreamHandler handler)
        throws MalformedURLException

  Creates a `URL` object from the specified `protocol`, `host`, `port` number, `file`, and `handler`. Specifying a `port` number of `-1` indicates that the URL should use the default port for the protocol. Specifying a `handler` of `null` indicates that the URL should use a default stream handler for the protocol, as outlined for: java.net.URL#URL(java.lang.String, java.lang.String, int, java.lang.String)

  If the handler is not null and there is a security manager, the security manager's `checkPermission` method is called with a `NetPermission("specifyStreamHandler")` permission. This may result in a SecurityException.

  Parameters:
    `protocol` - the name of the protocol to use.
    `host` - the name of the host.
    `port` - the port number on the host.
    `file` - the file on the host
    `handler` - the stream handler for the URL.
  Throws:
    `MalformedURLException` - if an unknown protocol is specified.
    `SecurityException` - if a security manager exists and its `checkPermission` method doesn't allow specifying a stream handler explicitly.
  See Also:
    `System.getProperty(java.lang.String)`, `setURLStreamHandlerFactory(java.net.URLStreamHandlerFactory)`, `URLStreamHandler`, `URLStreamHandlerFactory.createURLStreamHandler(java.lang.String)`, `SecurityManager.checkPermission(java.security.Permission)`, `NetPermission`

### URL

    public URL(String spec)
        throws MalformedURLException

  Creates a `URL` object from the `String` representation.

  This constructor is equivalent to a call to the two-argument constructor with a `null` first argument.

  Parameters:
    `spec` - the `String` to parse as a URL.
  Throws:
    `MalformedURLException` - If the string specifies an unknown protocol.
  See Also:
    `URL(java.net.URL, java.lang.String)`

### URL

    public URL(URL context,
               String spec)
        throws MalformedURLException

  Creates a URL by parsing the given spec within a specified context. The new URL is created from the given context URL and the spec argument as described in RFC2396 "Uniform Resource Identifiers : Generic Syntax" :

  >               <scheme>://<authority><path>?<query>#<fragment>

  The reference is parsed into the scheme, authority, path, query and fragment parts. If the path component is empty and the scheme, authority, and query components are undefined, then the new URL is a reference to the current document. Otherwise the any fragment and query parts present in the spec are used in the new URL. If the scheme component is defined in the given spec and does not match the scheme of the context, then the new URL is created as an absolute URL based on the spec alone. Otherwise the scheme component is inherited from the context URL. If the authority component is present in the spec then the spec is treated as absolute and the spec authority and path will replace the context authority and path. If the authority component is absent in the spec then the authority of the new URL will be inherited from the context. If the spec's path component begins with a slash character "/" then the path is treated as absolute and the spec path replaces the context path. Otherwise the path is treated as a relative path and is appended to the context path. The path is canonicalized through the removal of directory changes made by occurences of ".." and ".". For a more detailed description of URL parsing, refer to RFC2396.
  Parameters:
    `context` - the context in which to parse the specification.
    `spec` - the `String` to parse as a URL.
  Throws:
    `MalformedURLException` - if no protocol is specified, or an unknown protocol is found.
  See Also:
    `URL(java.lang.String, java.lang.String, int, java.lang.String)`, `URLStreamHandler`, `URLStreamHandler.parseURL(java.net.URL, java.lang.String, int, int)`

### URL

    public URL(URL context,
               String spec,
               URLStreamHandler handler)
        throws MalformedURLException

  Creates a URL by parsing the given spec with the specified handler within a specified context. If the handler is null, the parsing occurs as with the two argument constructor.
  Parameters:
    `context` - the context in which to parse the specification.
    `spec` - the `String` to parse as a URL.
    `handler` - the stream handler for the URL.
  Throws:
    `MalformedURLException` - if no protocol is specified, or an unknown protocol is found.
    `SecurityException` - if a security manager exists and its `checkPermission` method doesn't allow specifying a stream handler.
  See Also:
    `URL(java.lang.String, java.lang.String, int, java.lang.String)`, `URLStreamHandler`, `URLStreamHandler.parseURL(java.net.URL, java.lang.String, int, int)`

Method Detail

### set

    protected void set(String protocol,
                       String host,
                       int port,
                       String file,
                       String ref)

  Sets the fields of the URL. This is not a public method so that only URLStreamHandlers can modify URL fields. URLs are otherwise constant.
  Parameters:
    `protocol` - the name of the protocol to use
    `host` - the name of the host
    `port` - the port number on the host
    `file` - the file on the host
    `ref` - the internal reference in the URL

### set

    protected void set(String protocol,
                       String host,
                       int port,
                       String authority,
                       String userInfo,
                       String path,
                       String query,
                       String ref)

  Sets the specified 8 fields of the URL. This is not a public method so that only URLStreamHandlers can modify URL fields. URLs are otherwise constant.
  Parameters:
    `protocol` - the name of the protocol to use
    `host` - the name of the host
    `port` - the port number on the host
    `authority` - the authority part for the url
    `userInfo` - the username and password
    `path` - the file on the host
    `ref` - the internal reference in the URL
    `query` - the query part of this URL

### getQuery

    public String getQuery()

  Returns the query part of this `URL`.
  Returns:
    the query part of this `URL`.

### getPath

    public String getPath()

  Returns the path part of this `URL`.
  Returns:
    the path part of this `URL`.

### getUserInfo

    public String getUserInfo()

  Returns the userInfo part of this `URL`.
  Returns:
    the userInfo part of this `URL`.

### getAuthority

    public String getAuthority()

  Returns the authority part of this `URL`.
  Returns:
    the authority part of this `URL`.

### getPort

    public int getPort()

  Returns the port number of this `URL`. Returns -1 if the port is not set.
  Returns:
    the port number

### getProtocol

    public String getProtocol()

  Returns the protocol name of this `URL`.
  Returns:
    the protocol of this `URL`.

### getHost

    public String getHost()

  Returns the host name of this `URL`, if applicable.
  Returns:
    the host name of this `URL`.

### getFile

    public String getFile()

  Returns the file name of this `URL`.
  Returns:
    the file name of this `URL`.

### getRef

    public String getRef()

  Returns the anchor (also known as the "reference") of this `URL`.
  Returns:
    the anchor (also known as the "reference") of this `URL`.

### equals

    public boolean equals(Object obj)

  Compares two URLs. The result is `true` if and only if the argument is not `null` and is a `URL` object that represents the same `URL` as this object. Two URL objects are equal if they have the same protocol and reference the same host, the same port number on the host, and the same file and anchor on the host.
  Overrides:
    `equals` in class `Object`
  Parameters:
    `obj` - the URL to compare against.
  Returns:
    `true` if the objects are the same; `false` otherwise.

### hashCode

    public int hashCode()

  Creates an integer suitable for hash table indexing.
  Overrides:
    `hashCode` in class `Object`
  Returns:
    a hash code for this `URL`.

### sameFile

    public boolean sameFile(URL other)

  Compares two URLs, excluding the "ref" fields. Returns `true` if this `URL` and the `other` argument both refer to the same resource. The two `URL`s might not both contain the same anchor.
  Parameters:
    `other` - the `URL` to compare against.
  Returns:
    `true` if they reference the same remote object; `false` otherwise.

### toString

    public String toString()

  Constructs a string representation of this `URL`. The string is created by calling the `toExternalForm` method of the stream protocol handler for this object.
  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of this object.
  See Also:
    `URL(java.lang.String, java.lang.String, int, java.lang.String)`, `URLStreamHandler.toExternalForm(java.net.URL)`

### toExternalForm

    public String toExternalForm()

  Constructs a string representation of this `URL`. The string is created by calling the `toExternalForm` method of the stream protocol handler for this object.
  Returns:
    a string representation of this object.
  See Also:
    `URL(java.lang.String, java.lang.String, int, java.lang.String)`, `URLStreamHandler.toExternalForm(java.net.URL)`

### openConnection

    public URLConnection openConnection()
                                 throws IOException

  Returns a `URLConnection` object that represents a connection to the remote object referred to by the `URL`.

  A new connection is opened every time by calling the `openConnection` method of the protocol handler for this URL.

  If for the URL's protocol (such as HTTP or JAR), there exists a public, specialized URLConnection subclass belonging to one of the following packages or one of their subpackages: java.lang, java.io, java.util, java.net, the connection returned will be of that subclass. For example, for HTTP an HttpURLConnection will be returned, and for JAR a JarURLConnection will be returned.

  Returns:
    a `URLConnection` to the URL.
  Throws:
    `IOException` - if an I/O exception occurs.
  See Also:
    `URL(java.lang.String, java.lang.String, int, java.lang.String)`, `URLConnection`, `URLStreamHandler.openConnection(java.net.URL)`

### openStream

    public final InputStream openStream()
                                 throws IOException

  Opens a connection to this `URL` and returns an `InputStream` for reading from that connection. This method is a shorthand for:

  >          openConnection().getInputStream()

  Returns:
    an input stream for reading from the URL connection.
  Throws:
    `IOException` - if an I/O exception occurs.
  See Also:
    `openConnection()`, `URLConnection.getInputStream()`

### getContent

    public final Object getContent()
                            throws IOException

  Returns the contents of this URL. This method is a shorthand for:

  >          openConnection().getContent()

  Returns:
    the contents of this URL.
  Throws:
    `IOException` - if an I/O exception occurs.
  See Also:
    `URLConnection.getContent()`

### getContent

    public final Object getContent(Class[] classes)
                            throws IOException

  Returns the contents of this URL. This method is a shorthand for:

  >          openConnection().getContent(Class[])

  Returns:
    the content object of this URL that is the first match of the types specified in the classes array. null if none of the requested types are supported.
  Throws:
    `IOException` - if an I/O exception occurs.
  See Also:
    `URLConnection.getContent(Class[])`

### setURLStreamHandlerFactory

    public static void setURLStreamHandlerFactory(URLStreamHandlerFactory fac)

  Sets an application's `URLStreamHandlerFactory`. This method can be called at most once in a given Java Virtual Machine.

  The `URLStreamHandlerFactory` instance is used to construct a stream protocol handler from a protocol name.

  If there is a security manager, this method first calls the security manager's `checkSetFactory` method to ensure the operation is allowed. This could result in a SecurityException.

  Parameters:
    `fac` - the desired factory.
  Throws:
    `Error` - if the application has already set a factory.
    `SecurityException` - if a security manager exists and its `checkSetFactory` method doesn't allow the operation.
  See Also:
    `URL(java.lang.String, java.lang.String, int, java.lang.String)`, `URLStreamHandlerFactory`, `SecurityManager.checkSetFactory()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Java is a trademark or registred trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2000 Sun Microsystems, Inc. 901 San Antonio Road,
Palo, Alto, California, 94303, U.S.A All Rights Reserved. < /font >